/*	PCKBRD1 - A PC keyboard interface program for use with the Bagotronix
	DOS Stamp(tm).

	Copyright 2001 Bagotronix Inc.
	Authors: D. P. Knapp, Ivan Baggett
	Jan. 31, 2001:  first release

	This should be considered experimental software.  No express or implied
	warranties exist.  Use and modify for your needs.

	This program requires an AT or PS/2 style keyboard connected as follows:
	DOS Stamp          AT Keyboard
	PIO31 (JP1.17)     DATA (pin 2)
	PIO0 (JP1.21)      CLOCK (pin 1)
	VCC (JP1.33)       +5V (pin 5)
	GND (JP1.34)       GND (pin 4)
*/

#include <dos.h>
#include <stdio.h>

#include "stdinc.h"
#include "dosstamp.h"

BOOLEAN get_kbrd_data (void) {
	BOOLEAN state = 0;
	UWORD pio1;
	if (pio1 = (inport (PIO1_DATA) & 0x8000))   //poll pio input 31
		state = 1;                          //pc keyboard data line
	return(state);
}

BOOLEAN get_kbrd_clock (void) {
	BOOLEAN state = 0;
	UWORD pio1;
	if (pio1 = (inport (PIO0_DATA) & 0x0001))   //poll pio input 0
		state = 1;                          //pc keyboard clock line
	return(state);
}

int get_scan_code(void) {

int build_byte = 0;
int bit_mask = 0x01;
int i;

PIOconfig (0, PIOCFG_INPUT, 1);        //keyboard clock line
PIOconfig (31, PIOCFG_INPUT, 1);        //keyboard data line

while (get_kbrd_clock());                //wait for lo on clock; start bit
for (i=0;i<8;i++) {                      //get 8 data bits, LSB first
	while (!get_kbrd_clock());               //wait for hi on clock
	while (get_kbrd_clock());                //wait for lo on clock
	if (get_kbrd_data())                     //get data bit
	build_byte = (build_byte | bit_mask);    //build scan code
	bit_mask = (bit_mask * 2);               //shift bit mask
	}
while (!get_kbrd_clock());               //wait for hi on clock
while (get_kbrd_clock());                //wait for lo on clock; parity bit
while (!get_kbrd_clock());               //wait for hi on clock
while (get_kbrd_clock());                //wait for lo on clock; stop bit

PIOconfig (0, PIOCFG_OUTPUT, 0);        //keyboard clock line lo puts
					 //keyboard in buffering  mode
return(build_byte);
}


int main () {

int scan_code;

while(TRUE) {
	scan_code = get_scan_code();
	printf("\nscan code = %x", scan_code);
        }


return(0);
}

